﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace _158650
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
             panel1.Region = new Region(GetRoundedRect(new Rectangle(0, 0, panel1.Width, panel1.Height), 10));
             panel2.Height = panel1.Height - 10;
             panel2.Padding = new Padding( 10);
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.AllowColMoving = Infragistics.Win.UltraWinGrid.AllowColMoving.WithinBand;
            e.Layout.Override.AllowRowLayoutColMoving = Infragistics.Win.Layout.GridBagLayoutAllowMoving.AllowOriginXChange;
           
        }

        GraphicsPath GetRoundedRect(Rectangle rect, int r , int arrowHeight = 10)
        {
            rect.Height -= arrowHeight;
            #region rounded Edge rectangle
            GraphicsPath path = new GraphicsPath();
            path.StartFigure();
            Point startPoint = rect.Location;
            Point endPoint = startPoint;
            endPoint.Offset(rect.Width, 0);
            Rectangle leftEdgeRect = new Rectangle(startPoint, new Size( r*2, r*2));
            path.AddArc(leftEdgeRect, 179, 91);
            startPoint.Offset(r, 0);
            endPoint.Offset(-r*2,0);
            path.AddLine(startPoint, endPoint);
            Rectangle rightEdgeRect = new Rectangle(endPoint, new Size(r * 2, r * 2));
            path.AddArc(rightEdgeRect, 269, 91);
            startPoint = new Point(rect.Right, rect.Top);
            endPoint = startPoint;
            startPoint.Offset(0, r);
            endPoint.Offset(0, rect.Height - r * 2);
            path.AddLine(startPoint, endPoint);
            endPoint.Offset(-r * 2, 0);
            Rectangle rightBottomEdgeRect = new Rectangle(endPoint, new Size(r * 2, r * 2));
            path.AddArc(rightBottomEdgeRect, 359, 91);
            startPoint = new Point(rect.Right - r, rect.Bottom);
            endPoint = startPoint;
            endPoint.Offset(-(rect.Width - r*3), 0);
            path.AddLine(startPoint, endPoint);
            endPoint.Offset(-r * 2, -r * 2);
            Rectangle leftBottomEdgeRect = new Rectangle(endPoint, new Size(r * 2, r * 2));
            path.AddArc(leftBottomEdgeRect, 89, 91);
            startPoint = new Point(rect.Left, rect.Bottom - r);
            endPoint = startPoint;
            endPoint.Offset(0, -(rect.Height - r * 2));
            path.CloseFigure();

            #endregion raundedEdgeRectangle 
            path.StartFigure();
            Point firstPoint = new Point(rect.Left, rect.Bottom);
            firstPoint.Offset(rect.Width / 2, 0);
            Point midpoint = firstPoint;
            midpoint.Offset(0, arrowHeight);
            Point lastPoint = firstPoint;
            lastPoint.Offset(arrowHeight, 0);
            path.AddLines(new Point[] { firstPoint, midpoint, lastPoint });
            path.CloseFigure();


            return path;

        }

        private void ultraPanel1_PaintClient(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawPath(Pens.Red, GetRoundedRect(new Rectangle(0, 0, panel1.Width, panel1.Height), 10));
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Point p =this.PointToScreen( button1.Location);
            p.Offset(button1.Width/2 - panel1.Width / 2, - panel1.Height);

            ultraPopupControlContainer1.Show(p);
        }

        private void ultraPopupControlContainer1_Opening(object sender, CancelEventArgs e)
        {
            
        }

        private void ultraPopupControlContainer1_Opened(object sender, EventArgs e)
        {
            ((Infragistics.Win.Misc.UltraPopupControlContainer)(sender)).PopupControl.FindForm().TransparencyKey = System.Drawing.SystemColors.Control;
        }
    }
}
